<?php 
	// comment this back in to see any potential errors (NOTE: don't do it for production)
	// error_reporting(E_ALL);
	// ini_set('display_errors', 1);
	
	// make sure we're in utc time
	date_default_timezone_set( 'UTC' );
	
	 // returns the file query to add to a file, based on it's last modified date
	function getFileQuery( $filePath )
	{
		$fileQuery = rand(); // rand if the file doesn't exist
		if ( file_exists( $filePath ) ) 
		{
			$modifDate	= filemtime( $filePath );
			$date 		= new DateTime( "@$modifDate" );
			$fileQuery 	= $date->format( 'Ymd.Hi' );
		}
		return $fileQuery;
	}
?>
<!DOCTYPE html>
<html lang="en">
<head>
	<!-- force IE to render using the latest engine -->
	<meta http-equiv="X-UA-Compatible" content="IE=edge">
	
	<title>FlashFishersUnite</title>
	<meta charset="utf-8">
	<meta name="author" content="Damian Connolly (@divillysausages) & Alexis Bacot (@AreaEffect)" />
	<meta name="description" content="A fishing game made with Flash and Unity, for Ludum Dare 29" />
	
	<?php 
	// stylesheets - normalise, then main, then style
	echo "<link rel='stylesheet' href='css/normalize.css?" . getFileQuery( "css/normalize.css" ) . "'>
	<link rel='stylesheet' href='css/main.css?" . getFileQuery( "css/main.css" ) . "'>
	<link rel='stylesheet' href='css/style.css?" . getFileQuery( "css/style.css" ) . "'>";
	?>
	<link rel="shortcut icon" href="/sites/default/themes/dsThree/favicon.png" type="image/x-icon" />
</head>
<body>
	<?php
	echo "<script type='text/javascript' src='https://ssl-webplayer.unity3d.com/download_webplayer-3.x/3.0/uo/jquery.min.js'></script>
	<script type='text/javascript'>
		var unityObjectUrl = 'http://webplayer.unity3d.com/download_webplayer-3.x/3.0/uo/UnityObject2.js';
		if (document.location.protocol == 'https:')
			unityObjectUrl = unityObjectUrl.replace('http://', 'https://ssl-');
		document.write('<script type=\"text\/javascript\" src=\"' + unityObjectUrl + '\"><\/script>');
	</script>
	<script src='js/swfobject.js?" . getFileQuery( "js/swfobject.js" ) . "' type='text/javascript'></script>
	<script src='js/fish.js?" . getFileQuery( "js/fish.js" ) . "' type='text/javascript'></script>
	<script type='text/javascript'>
		var flashvars = {
		};
		var params = {
			menu: 'false',
			scale: 'noScale',
			allowFullscreen: 'true',
			allowScriptAccess: 'always',
			allowNetworking: 'all',
			bgcolor: '#0000A0',
			wmode: 'direct'
		};
		var attributes = {
			id:'FlashFishersUniteSWF',
			name:'FlashFishersUniteSWF'
		};
		swfobject.embedSWF('swf/FlashFishersUnite.swf?" . getFileQuery( "swf/FlashFishersUnite.swf" ) . "', 'swfPlayer', '900', '250', '11.6.0', 'swf/expressInstall.swf', flashvars, params, attributes);
	</script>
	<script type='text/javascript'>
		var config = {
			width: 900, 
			height: 400,
			params: { enableDebugging:'0' },
			id:'FlashFishersUniteUnity',
			name:'FlashFishersUniteUnity',
		};
		var u = new UnityObject2(config);

		jQuery(function() {

			var missingScreen = jQuery('#unityPlayer').find('.missing');
			var brokenScreen = jQuery('#unityPlayer').find('.broken');
			missingScreen.hide();
			brokenScreen.hide();
			
			u.observeProgress(function (progress) {
				switch(progress.pluginStatus) {
					case 'broken':
						brokenScreen.find('a').click(function (e) {
							e.stopPropagation();
							e.preventDefault();
							u.installPlugin();
							return false;
						});
						brokenScreen.show();
					break;
					case 'missing':
						missingScreen.find('a').click(function (e) {
							e.stopPropagation();
							e.preventDefault();
							u.installPlugin();
							return false;
						});
						missingScreen.show();
					break;
					case 'installed':
						missingScreen.remove();
					break;
					case 'first':
					break;
				}
			});
			u.initPlugin(jQuery('#unityPlayer')[0], 'unity/v0.unity3d?" . getFileQuery( "unity/v0.unity3d" ) . "');
		});
		Fish.init( 'FlashFishersUniteSWF', u );
	</script>"
	?>
	<div id="content">
		<h1>Happy Fishing - a game by Alexis Bacot &amp; Damian Connolly, for Ludum Dare #29</h1>
		<a href="#" id="game"></a>
		<div id="swf">
		
			<div id="swfholder">
				<!-- flash -->
				<div id="swfPlayer">
					<p><a href="http://www.adobe.com/go/getflashplayer">Get Adobe Flash player</a></p>
				</div>
			</div>
			
			<div id="unityholder">
				<!-- unity -->
				<div id="unityPlayer">
					<div class="missing">
						<a href="http://unity3d.com/webplayer/" title="Unity Web Player. Install now!">
							<img alt="Unity Web Player. Install now!" src="http://webplayer.unity3d.com/installation/getunity.png" width="193" height="63" />
						</a>
					</div>
					<div class="broken">
						<a href="http://unity3d.com/webplayer/" title="Unity Web Player. Install now! Restart your browser after install.">
							<img alt="Unity Web Player. Install now! Restart your browser after install." src="http://webplayer.unity3d.com/installation/getunityrestart.png" width="193" height="63" />
						</a>
					</div>
				</div>
			</div>
		</div>
		<div>
			<p id="numMsgs">Since you've been here, Flash and Unity have sent 0 messages to each other</p>
			<h3>Vote</h3>
			<p>Vote for the game! <a href="http://www.ludumdare.com/compo/ludum-dare-29/?action=preview&uid=12329">http://www.ludumdare.com/compo/ludum-dare-29/?action=preview&uid=12329</a></p>
			<h3>About</h3>
			<p>Happy Fishing is a colloraboration between Flash and Unity, with the 2D world above, and the 3D world beneath the surface. On the top, you have the Flash game, where you control a boat dumping love TNT into the ocean. Below, you have the Unity game, where you explode the TNT, drive the fish crazy with love, causing them to jump into the air. If two fish meet in the air, sparks fly, magic happens, and a new baby fish is brought into the world \o/</p>
			<p>Be careful not to let any fish land in your boat though, otherwise they'll die from a broken heart... :( (If it gets too much for your conscience to bear, you can enable <em>pacifist mode</em> and get mucho fish babies!)</p>
			<h3>Controls</h3>
			<p>LEFT and RIGHT move your ship, SPACE throws/detonates some love TNT</p>
			<h3>Roles</h3>
			<ul>
				<li>Unity - Alexis Bacot - <a href="http://area-effect.com/">http://area-effect.com/</a> - <a href="https://twitter.com/AreaEffect">@AreaEffect</a></li>
				<li>Flash, JS & PHP - Damian Connolly - <a href="http://divillysausages.com">http://divillysausages.com</a> - <a href="https://twitter.com/divillysausages">@divillysausages</a></li>
			</ul>
		</div>
	</div>
</body>
</html>