package fishing
{
	import flash.display.DisplayObject;
	import flash.display.MovieClip;
	import flash.display.Shape;
	import flash.display.StageAlign;
	import flash.display.StageScaleMode;
	import flash.events.Event;
	import flash.events.IOErrorEvent;
	import flash.events.ProgressEvent;
	import flash.utils.getDefinitionByName;
	
	/**
	 * ...
	 * @author Damian Connolly
	 */
	public class Preloader extends MovieClip 
	{
		/********************************************************************************/
		
		private var m_sw:Number	= 900;	// the stage width
		private var m_sh:Number = 300;	// the stage height
		private var m_bar:Shape = null; // our loading bar
		
		/********************************************************************************/
		
		public function Preloader() 
		{
			if (this.stage != null) 
			{
				this.stage.scaleMode 	= StageScaleMode.NO_SCALE;
				this.stage.align 		= StageAlign.TOP_LEFT;
			}
			this.addEventListener(Event.ENTER_FRAME, _onEnterFrame);
			this.loaderInfo.addEventListener(ProgressEvent.PROGRESS, _onProgress);
			this.loaderInfo.addEventListener(IOErrorEvent.IO_ERROR, _onIOError);
			
			// show loader
			this.m_bar = new Shape;
			this.m_bar.graphics.beginFill( 0xffffff );
			this.m_bar.graphics.drawRect( 0.0, 0.0, 100, 2.0 );
			this.m_bar.graphics.endFill();
			this.m_bar.x = this.m_sw * 0.5 - this.m_bar.width * 0.5;
			this.m_bar.y = this.m_sh * 0.5 - this.m_bar.height * 0.5;
			this.addChild( this.m_bar );
			
			// draw our outline
			this.graphics.lineStyle( 2.0, 0xffffff );
			this.graphics.drawRect( this.m_bar.x - 2.0, this.m_bar.y - 2.0, this.m_bar.width + 4.0, this.m_bar.height + 4.0 );
		}
		
		private function _onIOError(e:IOErrorEvent):void 
		{
			trace(e.text);
		}
		
		private function _onProgress(e:ProgressEvent):void 
		{
			// update loader
			var pc:Number 		= e.bytesLoaded / e.bytesTotal;
			pc					= ( pc < 0.0 ) ? 0.0 : ( pc > 1.0 ) ? 1.0 : pc;
			this.m_bar.scaleX	= pc;
		}
		
		private function _onEnterFrame(e:Event):void 
		{
			if (this.currentFrame == this.totalFrames) 
			{
				this.stop();
				this._onLoadingFinished();
			}
		}
		
		private function _onLoadingFinished():void 
		{
			this.removeEventListener(Event.ENTER_FRAME, _onEnterFrame);
			this.loaderInfo.removeEventListener(ProgressEvent.PROGRESS, _onProgress);
			this.loaderInfo.removeEventListener(IOErrorEvent.IO_ERROR, _onIOError);
			
			// TODO hide loader
			this.removeChildren();
			var mainClass:Class = getDefinitionByName("fishing.Main") as Class;
			this.parent.addChild( new mainClass() as DisplayObject );
			this.parent.removeChild( this );
		}
		
	}
	
}