package fishing.input 
{
	import com.divillysausages.ds.input.Key;
	
	/**
	 * The controls class
	 * @author Damian Connolly
	 */
	public class Controls 
	{
		
		/********************************************************************************/
		
		/**
		 * Is the left key pressed?
		 */
		public var isLeftPressed:Boolean = false;
		
		/**
		 * Is the right key pressed?
		 */
		public var isRightPressed:Boolean = false;
		
		/**
		 * Is the up key pressed?
		 */
		public var isUpPressed:Boolean = false;
		
		/**
		 * Is the down key pressed?
		 */
		public var isDownPressed:Boolean = false;
		
		/********************************************************************************/
		
		/**
		 * Called when there's been a key pressed
		 * @param key The key that was pressed
		 */
		public function onKeyDown( key:Key ):void
		{
			if ( key == Key.LEFT )			this.isLeftPressed 	= true;
			else if ( key == Key.RIGHT ) 	this.isRightPressed	= true;
			else if ( key == Key.UP )		this.isUpPressed	= true;
			else if ( key == Key.DOWN )		this.isDownPressed	= true;
		}
		
		/**
		 * Called when there's been a key released
		 * @param key The key that was released
		 */
		public function onKeyUp( key:Key ):void
		{
			if ( key == Key.LEFT )			this.isLeftPressed 	= false;
			else if ( key == Key.RIGHT )	this.isRightPressed = false;
			else if ( key == Key.UP )		this.isUpPressed	= false;
			else if ( key == Key.DOWN )		this.isDownPressed	= false;
		}
		
	}

}