package fishing.logic 
{
	import com.divillysausages.ds.core.IUpdateObj;
	import com.divillysausages.ds.DS;
	import fishing.assets.Resources;
	import flash.display.Bitmap;
	import flash.display.Sprite;
	/**
	 * ...
	 * @author Damian Connolly
	 */
	public class Splash extends Sprite implements IUpdateObj
	{
		
		/********************************************************************************/
		
		private var m_angle:Number 	= 0.0;	// angle for our anim
		private var m_startY:Number	= 0.0;	// where we start our anim
		
		/********************************************************************************/
		
		public function get active():Boolean { return this.parent != null; }
		
		/********************************************************************************/
		
		public function Splash() 
		{
			var bm:Bitmap 	= new Bitmap( DS.getAsset( Resources.IMAGE_SPLASH ).bitmapData );
			bm.x			= -bm.width * 0.5;
			bm.y			= -bm.height;
			this.addChild( bm );
		}
		
		public function destroy():void
		{
			DS.removeFromUpdate( this );
			if ( this.parent != null )
				this.parent.removeChild( this );
		}
		
		public function show( x:Number, y:Number ):void
		{
			this.m_startY	= y;
			this.x 			= x;
			this.y 			= this.m_startY + this.height;
			DS.addToUpdate( this );
		}
		
		public function update( dt:Number ):void
		{
			this.y 			= this.m_startY + this.height * 0.6 + Math.cos( this.m_angle ) * this.height * 0.5;
			this.m_angle 	+= dt * Math.PI;
			if ( this.m_angle > Math.PI * 2.0 ) 
				this.destroy();
		}
		
	}

}