package fishing.logic 
{
	import com.divillysausages.ds.core.IUpdateObj;
	import com.divillysausages.ds.DS;
	import com.divillysausages.ds.util.BMDMaker;
	import com.divillysausages.ds.util.Colour;
	import fishing.assets.Resources;
	import fishing.state.constants.SizeConstants;
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.PixelSnapping;
	import flash.display.Shape;
	import flash.display.Sprite;
	import flash.geom.Point;
	
	/**
	 * ...
	 * @author Damian Connolly
	 */
	public class Wave extends Sprite implements IUpdateObj
	{
		
		/********************************************************************************/
		
		private var m_moveAngle:Number 	= 0.0;	// angle used when animating move
		private var m_startX:Number		= 0.0;	// the start x for the wave
		private var m_startY:Number		= 0.0;	// the start y for the wave
		
		/********************************************************************************/
		
		public function get active():Boolean { return true; }
		
		/********************************************************************************/
		
		public function Wave( yOffset:Number ) 
		{
			// draw our graphics
			/*this.graphics.lineStyle( 10.0, 0xffffff, 0.2 + Math.random() * 0.4 );
			var angle:Number 	= 0.0;
			var waveH:Number	= 3.0 + Math.random() * 4.0;
			var waveStep:Number	= 5 + Math.random() * 10;
			var num:Number		= Math.ceil( ( DS.stage.stageWidth + 100 ) / waveStep );
			var x:Number 		= 0.0;
			for ( var i:int = 0; i <= num; i++ )
			{
				if ( i == 0 )
					this.graphics.moveTo( x, Math.sin( angle ) * waveH );
				else
					this.graphics.lineTo( x, Math.sin( angle ) * waveH );
				angle 	+= Math.PI * 0.1;
				x 		+= waveStep;
			}*/
			
			// create our bg
			var white:Bitmap 	= new Bitmap( DS.getAsset( Resources.IMAGE_WHITE ).bitmapData );
			white.width			= DS.stage.stageWidth + 150;
			white.height		= SizeConstants.OCEAN_SIZE_PX * 2.0;
			this.addChild( white );
			
			// create our graphics
			var bmd:BitmapData 	= DS.getAsset( Resources.IMAGE_WAVE ).bitmapData;
			var step:Number		= ( DS.stage.stageWidth + 100 ) / 20;
			var a:Array			= [];
			for ( var i:int = 0; i < 20; i++ )
			{
				var b:Bitmap 	= new Bitmap( bmd, PixelSnapping.NEVER, true );
				b.scaleX		= 0.7 + Math.random() * 0.6;
				b.scaleY		= b.scaleX;
				b.x 			= step * i - 10 + Math.random() * 2.0;
				b.y				= -b.height * 0.5 - 3 + Math.random() * 6;
				a.push( b );
			}
			a.sortOn( "scaleX" );
			for each( b in a )
				this.addChild( b );
				
			// copy it so we've less images
			var offset:Point 	= new Point;
			var copy:BitmapData = BMDMaker.convert( this, 1.0, offset );
			var copyBM:Bitmap	= new Bitmap( copy, PixelSnapping.NEVER, true )
			copyBM.y			= offset.y;
			this.removeChildren();
			this.addChild( copyBM );
				
			// scale us down a bit
			this.scaleY = 0.8;
			
			// set our start x/start y
			this.m_startX 	= DS.stage.stageWidth * 0.5 - this.width * 0.5;
			this.m_startY 	= DS.stage.stageHeight - SizeConstants.OCEAN_SIZE_PX + yOffset;// - 5 + Math.random() * 10;
			this.x			= this.m_startX;
			this.y			= this.m_startY;
			
			this.m_moveAngle = Math.random() * Math.PI * 2.0;
			
			// cache as a bitmap and add
			DS.addToUpdate( this );
		}
		
		public function update( dt:Number ):void
		{
			this.x = this.m_startX + Math.sin( this.m_moveAngle ) * 45;
			this.y = this.m_startY + Math.cos( this.m_moveAngle ) * 2;
			
			// update our move angle
			this.m_moveAngle += dt * 0.5;
			if ( this.m_moveAngle > Math.PI * 2.0 )
				this.m_moveAngle -= Math.PI * 2.0;
		}
		
	}

}