package fishing.state 
{
	import com.divillysausages.ds.core.GameState;
	import com.divillysausages.ds.DS;
	import com.divillysausages.ds.input.Input;
	import com.divillysausages.ds.input.Key;
	import fishing.assets.Resources;
	import fishing.input.Controls;
	import fishing.Main;
	import fishing.network.Ext;
	import fishing.state.constants.StateNames;
	import flash.events.KeyboardEvent;
	
	/**
	 * The state that creates everything
	 * @author Damian Connolly
	 */
	public class StateInit extends GameState 
	{
		
		public function StateInit() 
		{
			super( StateNames.INIT );
		}
		
		override public function begin():void 
		{
			super.begin();
			
			var main:Main = ( DS.main as Main );
			
			// create our resources
			new Resources;
			
			// create our objects
			main.js 		= new Ext;
			main.controls	= new Controls;
			
			// add our signals
			//main.js.signalOnKeyDown.add( main.controls.onKeyDown );
			//main.js.signalOnKeyUp.add( main.controls.onKeyUp );
			
			// bind the keys that will notify javascript, when we have the focus.
			// how the input works is this:
			// 	- if the web page has focus, js receives the events
			//	- if flash has focus, it tells js of any event
			//	- if unity has focus, it tells js of any event
			//	- if js is notified of an event, it tells flash
			// 	- flash reacts to the key event
			// it's a bit convoluted, but it makes sure that flash has input control
			// no matter who has focus
			Input.bindKeys( [Key.LEFT, Key.RIGHT, Key.UP, Key.DOWN], function( ke:KeyboardEvent ):void
			{
				// get the key
				var key:Key = Input.getKeyForCode( ke.keyCode );
				if ( ke.type == KeyboardEvent.KEY_DOWN )
					main.controls.onKeyDown( key );
					//main.js.notifyKeyDown( ke.keyCode );
				else
					main.controls.onKeyUp( key );
					//main.js.notifyKeyUp( ke.keyCode );
			}, Input.KEY_DOWN_UP );
			
			// switch to the waiting state
			main.fsm.changeState( StateNames.WAITING );
		}
		
	}

}