package fishing.state 
{
	import com.divillysausages.ds.core.GameState;
	import com.divillysausages.ds.DS;
	import fishing.assets.Resources;
	import fishing.Main;
	import fishing.state.constants.StateNames;
	import flash.display.Bitmap;
	import flash.text.TextField;
	import flash.text.TextFieldAutoSize;
	import flash.text.TextFormat;
	
	/**
	 * The state we go to when we're waiting on unity
	 * @author Damian Connolly
	 */
	public class StateWaiting extends GameState
	{
		
		/********************************************************************************/
		
		private var m_txt:TextField = null;
		
		/********************************************************************************/
		
		public function StateWaiting() 
		{
			super( StateNames.WAITING );
		}
		
		override public function begin():void 
		{
			var main:Main = ( DS.main as Main );
			
			// create our bg
			var bg:Bitmap = DS.getAsset( Resources.IMAGE_SKY ).bitmap;
			main.addChild( bg );
			
			// create our waiting text
			var tf:TextFormat 				= new TextFormat( "Trebuchet Ms", 12, 0xffffff );
			this.m_txt						= new TextField;
			this.m_txt.defaultTextFormat	= tf;
			this.m_txt.autoSize				= TextFieldAutoSize.LEFT;
			this.m_txt.text					= "Waiting for Unity...";
			this.m_txt.selectable			= false;
			this.m_txt.mouseEnabled			= false;
			this.m_txt.mouseWheelEnabled	= false;
			this.m_txt.multiline			= false;
			this.m_txt.wordWrap				= false;
			this.m_txt.x					= DS.stage.stageWidth * 0.5 - this.m_txt.width * 0.5;
			this.m_txt.y					= DS.stage.stageHeight * 0.5 - this.m_txt.height * 0.5;
			main.addChild( this.m_txt );
			
			// tell js that we're ready
			main.js.signalOnGlobalReady.add( this._onGlobalReady );
			main.js.notifyReady();
		}
		
		override public function end():void 
		{
			if ( this.m_txt.parent != null )
				this.m_txt.parent.removeChild( this.m_txt );
			this.m_txt = null;
		}
		
		/********************************************************************************/
		
		// called when we get the message that both flash and unity are ready
		private function _onGlobalReady():void
		{
			DS.paused = true;
			( DS.main as Main ).fsm.changeState( StateNames.PLAY );
		}
		
	}

}