package fishing.state.constants 
{
	/**
	 * Different constants relating to size and scale
	 * @author Damian Connolly
	 */
	public class SizeConstants 
	{
		
		/**
		 * The width of the ship, in meters
		 */
		public static const SHIP_W_M:Number = 12.0;
		
		/**
		 * The width of the screen in meters
		 */
		public static const SCREEN_W_M:Number = 100.0;
		
		/**
		 * The size of the ocean on the flash end, in pixels
		 */
		public static const OCEAN_SIZE_PX:Number = 40.0;
		
		/**
		 * The depth of the ocean in metres
		 */
		public static const OCEAN_DEPTH_M:Number = 40.0;
		
		/**
		 * The scale for the game
		 */
		public static const SCALE:Number = ( 900 / SCREEN_W_M );
		
		/**
		 * The inverse scale for the game
		 */
		public static const INV_SCALE:Number = 1.0 / SCALE;
		
	}

}